import 'package:flutter/material.dart';

class ButtonX extends StatelessWidget {
  final Function onPressed;
  final String buttonText;
  final Color buttonTextColor;
  final MaterialColor buttonColor;
  final MaterialColor? borderColor;
  final String? buttonSize;
  final double radius;
  final bool? isLoading;
  final MaterialColor? loaderColor;
  ButtonX({required this.onPressed, required this.buttonText, required this.buttonTextColor, required this.buttonColor, this.borderColor, this.buttonSize, required this.radius, this.isLoading, this.loaderColor});

  Widget loader(){
    return SizedBox(
      height: 20,
      width: 20,
      child: CircularProgressIndicator(
        strokeWidth: 2,
        valueColor: AlwaysStoppedAnimation<Color>(loaderColor ?? Colors.white),
        backgroundColor: loaderColor?.shade200 ?? Colors.grey.shade200,
      ),
    );
  }

  Widget button(){
    return MaterialButton(
      elevation: 0,
      height: ((buttonSize ?? "Small") == "Small") ? 36 : 50,
      minWidth: ((buttonSize ?? "Small") == "Small") ? double.minPositive : double.infinity,
      onPressed: (isLoading ?? false) ? (){} : (){
        onPressed();
      },
      shape: RoundedRectangleBorder(
          borderRadius: BorderRadius.circular(radius),
          side: BorderSide(color: (isLoading ?? false) ? buttonColor.shade100 : (borderColor ?? buttonColor))
      ),
      color: (isLoading ?? false) ? buttonColor.shade100 : buttonColor,
      child: (isLoading ?? false) ? loader() : Text(buttonText, style: TextStyle(fontSize: 16, fontWeight: FontWeight.w600, color: buttonTextColor),),
    );
  }

  @override
  Widget build(BuildContext context) {
    return ((isLoading ?? false) && buttonSize == "Small") ? loader() : button();
  }
}
